#! /usr/bin/python
#-*-coding:utf8-*-

from Tkinter import *
from tkMessageBox import *
import sys
import string

h1=Tk() #Hlavni okno
h1.title("Zadani souboru") 
l1=Label(h1,text="Vstupni soubor:")
l1.pack()
e1=Entry(h1)
e1.pack()

fin=""
def ok(a=None): #Obsluha tlacitka ok
    global fin
    fin_n=e1.get()
    try:
        fin=open(fin_n) 
        h1.destroy()
    except:
        showerror("Chyba","Zadany soubor neexisuje zadejte jej znovu!")

ok_but=Button(h1,text="OK",command=ok)
ok_but.pack()
h1.bind("<Return>",ok)

konec=Button(h1,text="Konec",command=sys.exit)
konec.pack()


h1.mainloop()
#Po zmacknuti ok se preskoci mainloop
def mysplit(a):return a.split(" ")
try:
    takt=fin.readline().rsplit() #Nacteni taktu
    noty=map(mysplit,map(string.rstrip,fin.readlines())) #nacte a rozdeli jednotlive noty
except:
    showerror("Chyba","Nepovedlo se zpracovat data ze zadaneho souboru")
    sys.exit()
fin.close()


WIDTH=1000
MEZI_RADKY=80
MEZI_ZNAKY=50
M=9  #Mezi jednotlivimi linkami
ZAC=40 #Mezera na zacatku

delka=2*(len(noty)+1) #Priblizna delka(o neco vetsi)

h2=Tk()
h2.title("Notovy editor")
can=Canvas(h2,height=(delka*MEZI_ZNAKY/WIDTH+1)*MEZI_RADKY+50,width=WIDTH)
can.pack()

def vykresli_txt(fn,x,y): #vykresli na zadanou pozici soubor v txt
    f=open(fn,"r")
    rozmery=map(int,f.readline().rstrip().split(" "))
    d=map(string.rstrip,f.readlines())
    f.close()
    for i in range(0,rozmery[0]):
        for j in range(0,rozmery[1]):
            if d[j][i]==".":
                pass
            elif d[j][i]=="@":
                can.create_rectangle(i+x,y-rozmery[1]+j,i+x,y-rozmery[1]+j)

def vykresli_osnovu(): #Vykresli notovou osnovu
    for i in range(0,(delka*MEZI_ZNAKY/WIDTH)+1):
        for r in range(0,5):
            can.create_line(0,i*MEZI_RADKY+ZAC+M*r,WIDTH,i*MEZI_RADKY+ZAC+M*r)

def vykresli_uvod(): #Vykresli houslovy klic a takt
    vykresli_txt("./txt/klic.txt",0,ZAC+M*5+5) #Houslovy klic
    if takt[0]=="3/4":
        vykresli_txt("./txt/takt_3.txt",MEZI_ZNAKY,ZAC+M*5-5)
    elif takt[0]=="4/4":
        vykresli_txt("./txt/takt_4.txt",MEZI_ZNAKY,ZAC+M*5-5)
    elif takt[0]=="5/4":
        vykresli_txt("./txt/takt_5txt",MEZI_ZNAKY,ZAC+M*5-5)
    else:
        showerror("Chyba v taktu","Na 1.radce souboru musi byt takt (3/4 , 4/4 nebo 5/4)")
        sys.exit()

vykresli_osnovu()
vykresli_uvod()

postup=["C","D","E","F","G","A","H","c","d","e","f","g","a","h"] #Jak jdou znaky postupne 
vtaktu=0
maxtakt=float(takt[0][0])

def vykresli_notu(p,n):# Parametry p-poradove cislo, n-nota
    
    pricti=0
    global vtaktu
    if n[0] == "pomlka":
        vtaktu+=float(n[1])
        
        if n[1]=="0.5":
            vyska=6
            velikost=0
            tecka=False
        if n[1]=="1":
            vyska=5
            velikost=1
            tecka=False
        if n[1]=="1.5":
            vyska=5
            velikost=1
            tecka=True
        if n[1]=="2":
            vyska=8
            velikost=2
            tecka=False
        if n[1]=="3":
            vyska=8
            velikost=2
            tecka=True
        if n[1]=="4":
            vyska=8.5
            velikost=4
            tecka=False
            smer=""
        vykresli_txt("./txt/pomlka_%s.txt"%(velikost),((p+2)*MEZI_ZNAKY)%WIDTH+10,
                                                        ((p+2)*MEZI_ZNAKY/WIDTH)*(MEZI_RADKY)+M*6+ZAC-int(M*(vyska)/2.0))
                                                        
        if tecka:
            can.create_rectangle(((p+2)*MEZI_ZNAKY)%WIDTH+27+5,
                                ((p+2)*MEZI_ZNAKY/WIDTH)*(MEZI_RADKY)+M*6-6+ZAC-int(M*(vyska)/2.0),
                                ((p+2)*MEZI_ZNAKY)%WIDTH+27+7,
                                ((p+2)*MEZI_ZNAKY/WIDTH)*(MEZI_RADKY)+M*6-4+ZAC-int(M*(vyska)/2.0),
                                fill="black")
    else:
        vyska=postup.index(n[0][0])
    
        krizek=""
        if len(n[0])==3:krizek="_krizek"
        smer="_nahoru"
        if vyska>6:smer="_dolu"
    
    
        vtaktu+=float(n[1])
        
        if n[1]=="0.5":
            velikost=0
            tecka=False
        if n[1]=="1":
            velikost=1
            tecka=False
        if n[1]=="1.5":
            velikost=1
            tecka=True
        if n[1]=="2":
            velikost=2
            tecka=False
        if n[1]=="3":
            velikost=2
            tecka=True
        if n[1]=="4":
            velikost=4
            tecka=False
            smer=""
    
             
        #print "./txt/nota%s%s_%s.txt"%(krizek,smer,velikost),(p+2)*MEZI_ZNAKY%WIDTH,(p+2)*MEZI_ZNAKY/WIDTH+20
        pricti=0 #Musi se pricti vyska otocene noty
        if smer=="_dolu":pricti=22
        if krizek=="_krizek":pricti+=3
        vykresli_txt("./txt/nota%s%s_%s.txt"%(krizek,smer,velikost),((p+2)*MEZI_ZNAKY)%WIDTH+10,
                                                                    ((p+2)*MEZI_ZNAKY/WIDTH)*(MEZI_RADKY)+M*6-3+ZAC-int(M*(vyska)/2.0)+pricti)

        if tecka:
            can.create_rectangle(((p+2)*MEZI_ZNAKY)%WIDTH+20+5,
                                ((p+2)*MEZI_ZNAKY/WIDTH)*(MEZI_RADKY)+M*6-6+ZAC-int(M*(vyska)/2.0)+pricti,
                                ((p+2)*MEZI_ZNAKY)%WIDTH+20+7,
                                ((p+2)*MEZI_ZNAKY/WIDTH)*(MEZI_RADKY)+M*6-4+ZAC-int(M*(vyska)/2.0)+pricti,
                                fill="black")
    
    #print n,vtaktu,maxtakt
    if vtaktu>=maxtakt:
        vtaktu=0
        can.create_line(((p+2)*MEZI_ZNAKY)%WIDTH+MEZI_ZNAKY/2+16,
                        (((p+2)*MEZI_ZNAKY/WIDTH)*MEZI_RADKY+ZAC),
                        ((p+2)*MEZI_ZNAKY)%WIDTH+MEZI_ZNAKY/2+16,
                        (((p+2)*MEZI_ZNAKY/WIDTH)*MEZI_RADKY+ZAC+M*4))
    
                

z=["C","Cis","D","Dis","E","F","Fis","G","Gis","A","Ais","H","c","cis","d","dis","e","f","fis","g","gis","a","ais","h","pomlka"]#Regulerni znaky
delky=["0.5","1","1.5","2","3","4"]
for i in range(0,len(noty)):
    if noty[i][0] not in z:
        showerror("Chyba","Nalezena chybna nota (%s)"%(string.join(noty[i]," ")))
        sys.exit()
    if noty[i][1] not in delky:
        showerror("Chyba","Nalezena chybna nota (%s) \n Spatna delka noty.\n Muze byt:\n 0.5, 1, 1.5, 2, 3, 4\n"%(string.join(noty[i]," ")))
        sys.exit()
    
    vykresli_notu(i,noty[i])   


def ok(a=None): #Obsluha tlacitka ok
    fout_n=e1.get()
    try:
        fout=open(fout_n,"w")
        fout.write(takt[0]+"\n")
        for i in noty:
            fout.write(i[0]+" "+i[1]+"\n")
        fout.close()
        
        showinfo("Ulozeno","Notovy zapis byl v poradku ulozen do souboru %s"%(fout_n))
        h1.destroy()
    except:
        showerror("Chyba","Nastala chyba pri ukladani")
        
        

def zpet():
    h1.destroy()

h1,e1=None,None
def uloz():
    global h1,e1
    h1=Tk() #Hlavni okno
    h1.title("Ulozeni") 
    l1=Label(h1,text="Vystupni soubor:")
    l1.pack()
    e1=Entry(h1)
    e1.pack()
    
    fout=""
    
    ok_but=Button(h1,text="OK",command=ok)
    ok_but.pack()
    zpet_but=Button(h1,text="Zpet",command=zpet)
    zpet_but.pack()
    h1.bind("<Return>",ok)
    
    h1.mainloop()    



ulozit_but=Button(h2,text="Ulozit",command=uloz)
ulozit_but.pack()

konec=Button(h1,text="Konec",command=sys.exit)
konec.pack()

h2.bind("<Escape>",sys.exit)
h2.mainloop()